<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 3.2//EN">

<HTML>

<HEAD>
<TITLE>Cours/TD - 5</TITLE>
<link REL="StyleSheet" TYPE="text/css" HREF="Costyle.css">

</HEAD>
<BODY BACKGROUND="../icons/snowhump.jpg">

<CENTER><H1>Cours/TD - (5)</H1>
</CENTER>
<P>
<p>


<TABLE width=100%>
 <TR><TD align=left><A HREF="comres4.html"><IMG SRC="../icons/gb_larr.gif" border=0 align=absmiddle></A></TD>
<TD align=right><A HREF="comres6.html"><IMG SRC="../icons/gb_rarr.gif" border=0 align=absmiddle></A></TD>
</TR>
</TABLE>
<p>
<FONT COLOR=#0000FF FACE="Helvetica,Arial" point-size=14pt>

<H3><FONT COLOR=#f00000>09.11.99</FONT></H3>
<p>


<H2>Cours</H2>


<H3>Enfin, la machine virtuelle (presque) complète</H3>

<EM>Déclaration :</EM>
<B>
Dans 90% d'ouvrages consacrés à la compilation vous trouverez l'ordre "natural" des sujets qui commencent par les programmes-source, décortiquent la structure textuelle, définissent les items lexicaux, ensuite traitent les structures syntaxiques, pour arriver enfin à la génération du code de bas niveau à travers d'un nombre de représentations intermédiaires.<p>

Pourquoi nous avons choisi la démarche "inverse"? Principalement parce que nous sommes intéressés plutôt par la sémantique de l'exécution du programme que par les transformations de la source.
<p>

Ensuite, parce que nous avons vu <I>beaucoup trop souvent</I> les cours qui commencent par l'analyse syntaxique et qui se terminent par l'analyse syntaxique, car on n'a pas le temps d'aborder la sémantique des programmes exécutés...
</B>

Notre point de départ est une sorte de "machine PostScript", mais réalisé directement en Haskell. <em>Encore une fois :</em> le choix de ce langage a été dicté par la facilité de codage, nous allons cependant discuter les optimisations de bas niveau, permettant de réaliser la machine en n'importe quel langage impératif aussi.
<p>

On peut imaginer une approche alternative suivante : on ne discute pas tellement l'analyse, on donne quelques recettes de cuisine suffisantes pour spécifier un langage acceptable par Lex et Yacc. Mais dans ce cas l'essentiel est également de savoir quel est le langage/machine virtuelle <SPAN class=ib>cible</SPAN> ! Des outils comme Lex et Yacc génèrent les parseurs, mais c'est à vous de préciser quelle est la forme du résultat de l'analyse.
<p>


Pour l'instant on ne discute pas les environnements (le décodage des variables). Ce problème a été déjà brièvement traité, nous y reviendrons encore. La base de tous les calculs ce sont les <I>valeurs</I>, les objets stockés sur les feuilles de l'arbre syntaxique, après leur éventuel décodage. Définissons le type de données qui représente les valeurs, "boxées", balisées par les constructeurs comme <TT>I</TT>, <TT>F</TT>, etc.
<P>
<a name="defval"> </a>
<PRE>
data Value = I Integer | F Double | S String 
                       | B Bool | C Code
type Dstack = [Value]
</PRE>
Pour l'instant c'est tout. La pile de données est une liste. Naturellement, on peut définir une représentation avec un tableau et l'indice qui spécifie la position du sommet, si on le veut. Le choix de données est arbitraire. Si on veut ajouter d'autres choses, comme les listes de valeurs, tableaux ou structures, etc., on pourra le faire ultérieurement. La dernière clause définit les objets procéduraux - le code défini par l'utilisateur. Le code n'est rien d'autre qu'une suite d'instructions élémentaires, donc nous pouvons déclarer :
<PRE>
type Code = [CodeItem]
</PRE>
où, encore une fois - si on veut travailler avec les tableaux, rien ne l'empêche. Une instruction élémentaire, un <TT>CodeItem</TT> mérite une discussion approfondie. En PostScript nous avons vu des programmes comme 
<PRE>
/fact {dup 0 eq {pop 1} {dup 1 sub fact mul} ifelse} 
      def
</PRE>
qui réalise la factorielle. Nous avons mentionné que :
<UL type="square">
<LI> Le typage dans PostScript est dynamique ; l'interprète regarde le tableau - code (c'est normalement un vecteur et non pas une liste), et vérifie le type de l'objet. Une constante littérale est empilée, un symbole décodé, et s'il represente une donnée, elle est également empilé. Si, par contre le symbole est associé avec un objet exécutable, il sera exécuté. Une certaine ambiguïté (conseptuelle) existe au niveau de  <TT>{ ... }</TT> figurant explicitement dans le programme. Ceci est une procédure, mais qui est empilée au lieu d'être exécuté. Donc, la machine Postscript prend beaucoup de décisions, et normalement il y a beaucoup de décodage. En particulier la "commande" <TT>{</TT> change le mode de la machine, elle passe de l'exécution à la compilation, la procédure litérale est une donnée comme les autres. Nous essairons de faire un peu mieux, et de n'avoir dans le code que <B>les commandes</B>, aucune donnée. Au lieu de placer une constante p. ex. 1, et de forcer l'empilement par l'interprète, on mettra dans le code l'instruction d'empilement de cette constante. Ceci peut être fait avant, par le compilateur.

<LI> Les primitives comme <TT>dup, mul</TT>, etc., travaillent directement sur la pile de données. Notre <TT>CodeItem</TT> sera donc un objet fonctionnel qui prend pour paramètre la pile de données.

<LI> La procédure PostScript se termine quand le code est épuisé. L'interprète vérifie donc avant de passer à l'instruction suivante si elle existe. Dans notre code ceci sera assuré toujours. Le retour sera toujours explicit, effectué par la commande <TT>ret</TT>. (Cette commande peut se trouver au milieu du code.)

<LI> Il n'est pas question que la machine virtuelle soit récursive, elle doit être la plus plate possible. Ainsi nous pouvons contrôler nous-mêmes tout le contexte, les piles, etc., ce qui qui est bon pour le déboguage et pour l'efficacité. Nous allons gérer explicitement la <EM>pile de retours</EM> qui contient le code en train de s'exécuter, et tous les modules qui ont appelé ce code, et attendent qu'il se termine.
</UL>
Toutes nos commandes prendront donc comme arguments <I>deux</I> piles, la pile de données, et la pile de retours. cette dernière sera spécifié non pas comme une liste, mais comme une "quasi-liste" définié par nos propres soins. Ceci est uniquement pour avoir un peu plus de richesse syntaxique, on peut utiliser les listes ou les tableaux (et en principe les piles peuvent être des objets globaux, et non pas les paramètres ; les primitives <I>modifient les piles sur place</I> au lieu de retourner des nouvelles piles, modifiées.
On commence par la définition d'un opérateur infixe <TT>(:&gt;)</TT> associatif à droite, exactement comme <TT>(:)</TT> :
<PRE>
infixr 5  :&gt;
</PRE>
Pour d'autres opérateurs regardez <B>enfin</B> le <A HREF="Prelude.hs.html">Prélude Standard de Haskell</A>.
<p>

<a name="codspec"></a>
Cet opérateur/constructeur définira le type "pile de retours":
<PRE>
data Rstack = Empty | Code :&gt; Rstack
type CodeItem = (Rstack -&gt; Dstack -&gt; (Rstack,Dstack))
</PRE>
C'est-à-dire : une commande prend les deux piles, en fait quelque chose et retourne deux nouvelles piles "emballées" ensemble. La commande suivante prendra ces nouveaux arguments. La machine virtuelle exécute les instructions dans une boucle, qui récupère le code toujours du sommet de la pile de retours. Dans un langage impératif les piles peuvent être des tableaux globaux, et non pas des paramètres. Une telle optimisation est un joli sujet d'examen. Voici le code de la machine virtuelle, et une fonction d'interfaçage qui initialise les piles. Le résultat est la pile de données finale.
<PRE>
machine Empty p = p
machine ((instr:rcode):&gt;rq) pdonn = 
 let (nrp,np) = instr (rcode:&gt;rq) pdonn
 in  machine nrp np

interp code = machine (code:&gt;Empty) []
</PRE>
Pour pouvoir tester la machine il faut prévoir quelques instructions primitives, par exemple l'empilement des constantes, les primitives de manipulation de la pile de données - comme en PostScript, et quelques opérations arithmétiques. Toites ces opérations sont très courtes, et elles sont définies à lextérieur de la <TT>machine</TT>. Voici quelques exemples :
<PRE>
ldc x rp p = (rp,x:p)  -- Empiler une constante
ldf x = ldc (F x)      -- Abréviations
ldi x = ldc (I x)
ldcod c = ldc (C c)
ldb x = ldc (B x)
-- <I>quelques opérations flottantes</I>
addf rp ((F x):(F y):p) = (rp,(F (x+y)):p)
mulf rp ((F x):(F y):p) = (rp,(F (x*y)):p)
subf rp ((F x):(F y):p) = (rp,(F (y-x)):p)
sinf rp (F x : p) = (rp,F (sin x))
-- ... <I>et entières</I>
</PRE>
Et nos manipulations préférées de la pile :
<PRE>
dup rp l@(x:p) = (rp,x:l)
pop rp (x:p) = (rp,p)
exch rp (x:y:q) = (rp,y:x:q)

indx rp (I n : p) = (rp,ixl n p:p) where
 ixl 0 (x:_) = x
 ixl n (_:q) = ixl (n-1) q
</PRE>
La dernière fonction c'est l'<TT>index</TT> en PostScript. On n'est pas obligé de définir explicitement la boucle <TT>ixl</TT>, la librairie standard de Haskell possède l'opérateur qui trouve le n-ième élément d'une liste. <B>Je vous conseille vivement de lire enfin la documentation de Haskell</B>. Maintenant nous pouvons faire un test :
<PRE>
res = interp [ldf 4.0, dup, dup, mulf, mulf, ret]
</PRE>
et on obtient <TT>F 64.0</TT> sur la pile de données. Mais qu'est-ce que ce <TT>ret</TT>? Cette fois nous allons manipuler la pile de retours. Le retour écrase le sommet de cette pile, donc la machine reprendra avec son prédecesseur  - le module appelant. Par contre, l'appel à une procédure utilisateur l'empile, et c'est tout.
<PRE>
ret (_:&gt;rp) p = (rp,p)
call proc rp p = (proc:&gt;rp,p)
</PRE>
À présent nous pouvons définir une procédure à nous et la tester
<PRE>
cube = [dup, dup, mulf, mulf, ret]
res = interp [ldf 3.0, dup, call cube, addf, ret]
</PRE>
ce qui doit donner 30.<p>

(Notons d'ailleurs que la facilité du codage des objets fonctionnels en Haskell nous a permis de construire l'interprète d'un petit "langage" (commandes assemblées dans des listes) dont "le compilateur" est le compilateur de Haskell lui-même...) <p>

Il serait judicieux de définir une procédure primitive <TT>tail_call</TT>, qui remplace la combinaison <TT>[ ... call f, ret, ...]</TT>. L'appel terminal évite de surcharger la pile de retours. Sa définition est triviale, l'implantation avec les tableaux et pointeurs devient beaucoup moins lisible. Ici nous aurons :
<PRE>
tail_call proc (_:&gt;rp) p = (proc:&gt;rp,p)
-- <I>et un bonus supplémentaire :</I>
stop rp p = (Empty,p)
</PRE>
Dans un cours pédagogique il faut être élégant et éviter d'utiliser les gros mots, cependant il faut que le lecteur sache que <TT>tail_call</TT> n'est rien d'autre qu'une implantation fonctionnelle du notoire <B>go to</B> ! 
<p>
La dernière fonction vide la pile de retours, ce qui effectivement arrête la machine. Qelque chose de ce genre peut être utilisée pour lancer les exceptions/erreurs irrécupérables.

<H3>Les conditionnelles et autres structures de contrôle</H3>

Pour que nos séquences de code soient universelles, elles doivent inclure quelques mécanismes conditionnels, au moins <TT>if - then - else</TT>. Définissons - comme en PostScript - deux conditionnelles, l'exécution conditionnelle d'une procédure : <TT>iff</TT> (le mot <TT>if</TT> est réservé en Haskell), et l'alternative <TT>ifelse</TT>. Voici leur code :
<PRE>
iff rp (C proc : (B cnd) : p) 
  | cnd = (proc:&gt;rp,p)
  | otherwise = (rp,p)

ifelse rp (C pre : C prt : B cnd : p) 
  | cnd = (prt:&gt;rp,p)
  | otherwise = (pre:&gt;rp,p)
</PRE>
La procédure <TT>iff</TT> attend sur la pile de données un objet Booléen couvert par une procédure. Si la condition est satisfaite, la procédure est mise sur la pile de retours, et donc elle sera exécutée immédiatemment après. <TT>ifelse</TT> empile l'une de deux procédures alternatives. Nous devons préparer quelques procédures qui génèrent les conditions, par exemple les relations arithmétiques, <TT>gt, eq, ne,</TT> etc., comme en PostScript. Par exemple :
<PRE>
eq rp (x:y:p) = (rp,B (x==y) : p)
gt rp (x:y:p) = (rp,B (y&gt;x) : p)
</PRE>
etc. Mais - une seconde... <TT>eq</TT>, etc. marchent, si les relations de plus bas niveau, <TT>==, &gt;, &lt;=,</TT> etc. soient implementées. On doit pouvoir comparer les objets de type Value. Ceci en principe est simple, mais avec un peu de "magie syntaxique":
<PRE>
instance Eq Value where
 F x == F y = x==y
 B x == B y = x==y
 I x == I y = x==y
 ....

instance Ord Value where
 F x &lt;= F y = x&lt;=y
 F x &gt; F y = x&gt;y
 B x &gt; B y = x&gt;y
 I x &gt; I y = x&gt;y
</PRE>
etc. Nous définissons les relations pour un nouveau type défini par nous de manière extrêmement naturelle, mais il ya une noueauté, la ligne <TT>instance</TT>. <p>

Ceci est notre premier rencontre avec le <EM>système de classes de types</EM>, qui est une variante fonctionnelle de la philosophie de surcharge orientée-objet. Nous ne pouvons pas discuter tous les <a href="javascript:alert('Allez-vous lire cette sacrée documentation un jour,\nou non ?!')">détails</a> ici. Très brièvement : si nous voulons que dans un langage <B>typé statiquement</B> une fonction (ou opérateur) s'applique à des données de types différents - comme les fonctions génériques en C++, il faut prévoir l'existence de <I>dictionnaires de méthodes (ou fct. génériques)</I> où le système cherche la définition de la sémantique de - par exemple - "==", pour tel ou tel type de données. Les détails d'implantation sont complexes, mais en Haskell la création de l'entité qui gère cette généricité est très simple. Si on veut que l'égalité (et l'inégalité) soit un opérateur surchargé, on définit une <EM>classe</EM>, par exemple
<PRE>
class Eq a where
 (==) :: a-&gt;a-&gt;Bool
 (!=) :: a-&gt;a-&gt;Bool
 x != y = not (x==y)   -- Implem. par défaut
</PRE>
dont la lecture est : <B>il existe un ou plusieurs types <TT>a</TT> tels, que pour ce type il existe l'opérateur <TT>(==)</TT> qui prend deux valeurs du type  <TT>a</TT>, et retourne un Booléen </B>. Ensuite les types concernés sont déclarés comme des instances de cette classe <TT>Eq</TT>. Le Predude Standard de Haskell contient plusieurs classes prédéfinies, notamment <TT>Eq</TT> avec l'égalité, <TT>Ord</TT> pour des relations de superiorité ou infériorité, <TT>Num</TT> où on spécifie quelques opérateurs arithmétiques, <TT>Floating</TT> avec des fonctions comme sin, exp, etc. et autres. Notamment, pour chaque objet qui pourra être imprimé, il faut déclarer une procédure d'affichage qui est une fonction-membre de la classe <TT>Show</TT>. Dans cette classe on définit une procédure qui transforme un objet en chaîne de caractères. (C'est ça l'affichage, rien d'autre.) Voici notre classe <TT>Show</TT> pour <TT>Value</TT> (ne regardez pas les détails. Lisez la doc d'abord...)
<PRE>
instance Show Value where
 showsPrec _ (I n) = shows n
 showsPrec _ (F n) = shows n
 showsPrec _ (S s) = shows s
 showsPrec _ (B b) = shows b
 showsPrec _ (C cod) = showList cod
</PRE>
Voici la définition de la procédure qui calcule la factorielle :
<PRE>
fact = [dup, ldi 0, eq,
        ldcod [pop, ldi 1,ret],
        ldcod [dup,ldi 1,subi,call fact,muli,ret],
        ifelse,ret]

res1 = interp [ldi 6,call fact,ret]
</PRE>
ainsi que le test qui calcule 720.
<p>
Pour terminer : si on veut implanter une telle machine en utilisant un langage impératif on pourra (peut-être devra pour des raisons d'efficacité de bas niveau) effectuer les modifications suivantes :
<UL type="square">
<LI> Utiliser les vecteurs et les indices au lieu des listes ; pour le programme et pour les deux piles. 
<LI> La <TT>machine</TT> peut être une simple boucle ; la boucle <TT>while</TT> peut être drastiquement optimisée - on effectue simplement <tt>code_ind--</tt> ce qui fait exécuter encore une fois <TT>while</TT> (<TT>whilp</TT>) après avoir traité la procédure empilée.
<LI> Le  <TT>tail_call</TT> (ou <B>goto</B>) est réalisé par <TT>code_ind=nouveau</TT> si le segment de code qui contient cette adresse se trouve sur le sommet de la pile de retour, sinon il faut recharger le nouveau segment. On voit immédiatemment que ceci n'a pas de sens si le code entier est mis dans <I>un</I> tableau.
<li> Les commandes primitives sont représentées par les pointeurs sur les fonctions correspondantes, codées p. ex. en "C". Le seul problème <B>non-trivial</B> ici est l'usage de procédures parametrées (fermetures) comme <TT>ldi 5</TT>, ou <TT>whilp <I>proc</I></TT> qui a été abordé en TD. Ici on revient à une des questions posées avant la construction de la machine : comment <I>insérer une donnée</I> dans le code? <p>

Il n'y a pas de solution banale de cette question, le seul moyen visible est de compliquer la machine virtuelle, et d'analyser dynamiquement "le sens" des pointeurs qui constituent le code. Bien sûr, la <B>vraie</B> solution efficace, est de ne pas représenter le code comme une suite de pointeurs arbitraires, mais - comme nous l'avons fait - toujours par des pointeurs sur les objets fonctionnels, et ceci est le rôle du compilateur (pré-processeur) du code.
</UL>
<P>

Cependant - indépendamment de la représentation - un autre problème est beaucoup plus important. Notre machine virtuelle est - en principe - programmable par un être humain, 
on "bricole" les algorithmes qui manipulent la pile des données avec <TT>dup, exch, pop</TT>, etc. Ceci est mal adapté aux langages évolués, avec des procédures parametrées et variables locales. Un code régulier produit par le compilateur accède de manière régulière aux éléments de la pile sans changer - si possible - l'emplacement des items. À la fin, on écrase le dernier <I>stack frame</I>.
<p>

Ceci sera discuté prochainement


<!-- ********************************************************* --><p>
<CENTER><IMG SRC="../icons/limarro.gif" WIDTH="576" HEIGHT="9" ALT="">
</CENTER>
<p>

<p>
<H2>TD</H2>
<p>


<H3>La boucle while et son application</H3>

Avec la primitive qui réalise l'appel terminal, nous pouvons construire (manuellement) les fonctions itératives qui exploitent la récursivité terminale. Mais pourquoi ne pas réaliser une boucle classique comme en PostScript, une fonction <TT>while</TT> qui attend, exactement comme <TT>iff</TT>, un Booléen et une procédure sur la pile des données. Les deux sont dépilées, et si la condition est fausse, l'instruction ne fait rien.<p>

Si la condition est satisfaite, l'instruction fait deux choses : exécute la procédure, et restaure le code d'origine, c'est-à-dire le code qui suit la boucle, précédé encore une fois par la commande de boucle. La procédure doit de sa part restaurer la nouvelle condition. Voici le code, où la fonction <TT>while</TT> utilise une fonction accessoire <TT>whilp</TT> qui récupère la procédure de boucle de la pile de données, et l'installe comme son paramètre.
<PRE>
while rp (C proc : p) = whilp proc rp p

whilp proc rp@(cod:&gt;rq) (B cnd : p)
 | cnd = (proc :&gt; (whilp proc : cod) :&gt; rq,p)
 | otherwise = (rp,p)
</PRE>
Et voici la réalisation itérative de la factorielle, et son test :
<PRE>
itfact = [dup, ldi 1, exch, ldi 0, gt, 
          ldcod [ldi 1, indx, muli, exch, ldi 1, subi, exch,
                 ldi 1, indx, ldi 0, gt, ret], while,
          exch, pop, ret]

res2 = interp [ldi 100,call itfact,ret]
</PRE>
On est loin d'épuiser toute la puissance de notre machine, mais il serait utile de voir comment peut-on compiler un langage "classique", avec les variables, paramètres, etc., ayant pour cible cette machine.


<!-- ********************************************************* --><p>
<CENTER><IMG SRC="../icons/limarro.gif" WIDTH="576" HEIGHT="9" ALT="">
</CENTER>
<P>

<H3>Expressions régulières</H3>
<p>

Habituellement l'analyse est divisée en deux parties : syntaxique, qui vérifie la structure des constructions linguistiques : expressions, structures de contrôle, etc., et l'analyse lexicale qui traite les "mots", les items. Il n'y a pas vraiment de différence entre les deux, l'analyse lexicale est normalement plus simple, et sa réalisation efficace à l'aide des automates finis et expressions régulières est considérée "professionnelle", sauf si le <I>domaine</I> de l'analyse est le lexique, et on cherche à décortiquer les mots, travailler sur les suffixes, préfixes, etc., à ce moment-là, même pour les mots il faut utiliser des techniques de parsing plus puissantes. Les automates et les expressions régulières ont déjà été abordés par un autre cours. Rappelons brièvement, qu'une expression régulière est une suite de caractères "normaux" (alphanumériques, ou quelques spéciaux sans signification particulière). La chaîne vide - notée ici par le symbole EPS est également régulière. Nous pouvons ensuite
<OL>
<LI> Les concaténer et former les mots plus longs.
<LI> Choisir, l'alternative est <i>exp<SUB>1</SUB> | exp<SUB>2</SUB></i>
<LI> Prendre zéro, ou plusieurs occurrences d'une expression <I>x</I> : <I>x</I>*, ce que l'on appelle la fermeture de Kleene.
</OL>
Nous pouvons utiliser les parenthèses pour assembler les sous-expressions, et il faut prévoir un caractère d'échappement pour noter les littéraux qui risquent d'être confondus avec les métacharactères, comme les parenthèses, la barre, l'étoile, etc. On peut utiliser la forme <B>"|"</B>, ou <B>\*</B>, etc. Plusieurs conventions coexistent. Il existe encore quelques abréviations/variantes, par exemple
<OL start="4">
<LI> La fermeture positive - une ou plusieurs occurrences : <I>x</I>+.
<LI> Zéro ou une instance : <I>x</I>?.
</OL>
Il est évident que nous pouvons établir les équivalences :
<UL>
<LI> <I>x</I>+ = <I>x x</I>*
<LI> <I>x</I>* = EPS | <I>x</I>+
<LI> <I>x</I>? = EPS | <I>x</I>
</UL>
et, finalement, la fermeture de Kleene est la solution d'une équation récurrentielle (itérative, à droite): <I>xstar</I> = EPS | <I>x xstar</I>. Mais nous ne pouvons introduire à volonté des variables qui obéissent des équations arbitraires, seulement la récursivité "linéaire" est permise, sinon l'automate de reconnaissance aurait besoin d'une pile (dans de rares cas, plutôt artificiels, un compteur suffirait).
<p>

Pour faciliter la construction de <I>patterns</I> lexicaux plus complexes utiles dans la recherche et dans la définition des lexèmes moins triviaux, on trouve d'autres éléments du langage des regexps.
<OL start="6">
<LI> Le choix d'un parmi plusieurs caractères, ou dans l'intervalle : <TT>[128a-z]</TT>. entre crochets plusieurs méta-caractères perdent leur caractère méta (mais quel jeu de mots...)
<LI> Symboles de positionnement : ^ - début de ligne, $ - fin de ligne.
<LI> Un certain nombre d'occurrences : <I>x</I>{n<SUB>1</SUB>,n<SUB>2</SUB>} ; on peut spécifier <I>un</I> n, un intervalle, ou l'intervalle infini (n ou plus) - {n,}.
<LI> <I>x</I>/<I>y</I> - équivalent à <I>x</I>, mais à condition qu'il soit suivi par <I>y</I>.
<li> Le point : .  signifie - un caractère quelconque.
</OL>
Ce n'est pas tout. Le générateur de scanners <B>lex/Flex</B> ou l'outil de recherche <B>grep</B> (aussi: <B>sed, awk, perl</B>, etc.) offent encore autres formes syntaxiques élargissant les <I>regexps</I> de base, mais pour l'instant nous n'envisageons pas de discuter toute cette richesse de formes. Faisons simplement quelques exercices de base.
<p>

Voici l'expression qui filtre une chaîne composée de <B>a</B> ou <B>b</B>, avec deux <B>a</B> consécutifs : <B>(a|b)*aa(a|b)*</B> . Comment construir le filtre inverse? Pour le choix d'<I>un</I> caractère, c'est facile : <B>[-a-z]</B>, l'expression-intervalle avec le tiret derrière le crochet ouvrant signifie la négation. Mais <SPAN class=ib>on ne peut pas</SPAN> "nier" une regexp quelconque, il faut construire la négation <I>ab ovo</I>. Voici la solution : <B>b*(ab+)*a?</B> .
<p>

<EM>Les commentaires.</EM> Un de vous a proposé la solution suivante du problème de filtrage des commentaires en Pascal : <TT>(*  ... *)</TT> : <B>"(*".*"*)"</B> . Cela peut marcher pratiquement, si l'application qui utilise les regexps applique le protocole global de reconnaissance, et - par exemple - réalise les filtres génériques comme <B>.*</B> de manière suivante : 
<UL type="disc">
<LI> Prétendre que le filtre correspond à la chaîne vide, et voir si ça marche.
<LI> En cas d'échec des filtres suivants, reprendre <B>.*</B>, et l'apparier avec un seul caractère. ensuite deux, trois, ...
</UL>
... jusqu'à l'échec final (buffer d'entrée épuisé, ou la contrainte de ne pas dépasser une ligne violée), ou la réussite. Ceci est un algorithme non-déterministe inefficace, bon pour une courte recherche, mais pas tellement pour la construction d'un analyseur lexical d'un compilateur. Normalement la convention utilisée pour les filtres génériques est : aller jusqu'au but, essayer de filtrer la sous-chaîne la plus longue possible. Dans notre cas le filtre <B>.*</B> est un puits sans fond.
<p>

Il faut scanner le texte de manière consciencieuse, et dès que l'on trouve l'étoile, la sonnette d'alarme sonne, et si le caractère suivant n'est pas une parenthèse fermante, on répète la manipulation. Voici une solution possible, pas forcément la meilleure : <br>

<B>"(*"([-*]*"*"[-)])*"*)"</B> . 
<EM>Exercice.</EM> Cette solution est "légèrement" non-déterministe aussi, il faut éventuellement reculer après avoir trouvé l'étoile et la parenthèse fermente. Essayer d'optimiser la solution (en temps de calcul, elle peut être plus longue).
<p>


<EM>Automates et regexps.</EM> On connaît la relation entre les expressions régulières et les automates finis, et le slogan du jour est : c'est une bonne idée de construire un scanneur comme un automate, car la programmation des automates est simple, et la traduction des regexps en automates est simple également. On commence par les automates non-déterministes, et les optimise (ce qui les complique, mais rend plus efficaces ; cette optimisation peut être automatique). Cette philosophie est bonne, mais elle n'est pas universelle. Les automates, surtout les DFA (automates déterministes) ce sont des "usines à gas". Pour faire un tout petit interprète d'un langage suffisamment simple on n'a pas besoin d'eux ; il est un peu ridicule construire un petit programme ajouté à un scanneur dix fois plus grand, généré par Flex...
<p>

Notre exercice suivant consistait à reconnaître le sens de l'automate

<CENTER><IMG SRC="autopa.gif" WIDTH="262" HEIGHT="243" ALT=""></CENTER>
<p>
où le premier noeud en haut à gauche est le noeud initial et en même temps terminal (le seul légal en fin de chaîne). La réponse trouvée par vos soins est évidente : le nombre de <B>a</B> et le nombre de <B>b</B> doivent être paires. Ensuite on a essayé de construire la regexp équivalente, et ceci n'était déjà pas si facile. Voici la réponse : <p>

<B>(aa | bb | (ab | ba)(aa | bb)*(ab | ba))*</B>
<p>

D'une certaine façon il est plus facile à penser de manière récursive. Si <SPAN class=ib>papb, iaib</SPAN> sont des non-terminaux qui dénotent des chaînes avec le nombre paire de a et de b, ou impaire des deux, ces variables satisfont les équations : <br>
<B><I>papb</I> = EPS | (aa|bb) <I>papb</I> | (ab|ba) <I>iaib</I></B> <br>
<B><I>iaib</I> = &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;(aa|bb) <I>iaib</I> | (ab|ba) <I>papb</I></B>
<p>

<EM>Exercice.</EM> Peut-on réduire ces deux équations à une seule, pour <SPAN class=ib>papb</SPAN>? (Joli sujet d'examen, non?)
<p>

<p>
<TABLE width=100%>
 <TR><TD align=left><A HREF="comres4.html"><IMG SRC="../icons/gb_larr.gif" border=0 align=absmiddle></A></TD>
<TD align=right><A HREF="comres6.html"><IMG SRC="../icons/gb_rarr.gif" border=0 align=absmiddle></A></TD>
</TR>
</TABLE>
<p>


</FONT>
</BODY>

</HTML>
